"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const forms_1 = require("@angular/forms");
const getPropertyName_1 = require("./getPropertyName");
class FormGroupTypeSafe extends forms_1.FormGroup {
}
exports.FormGroupTypeSafe = FormGroupTypeSafe;
// tslint:disable-next-line:max-classes-per-file
class FormControlTypeSafe extends forms_1.FormControl {
}
exports.FormControlTypeSafe = FormControlTypeSafe;
exports.generateGetSafeFunction = (gr) => {
    return (propertyFunction) => {
        const getStr = getPropertyName_1.getPropertyName(propertyFunction.toString());
        const p = gr.get(getStr);
        return p;
    };
};
exports.generateSetControlSafeFunction = (gr) => {
    return (propertyFunction, control) => {
        const getStr = getPropertyName_1.getPropertyName(propertyFunction.toString());
        gr.setControl(getStr, control);
    };
};
// tslint:disable-next-line: max-classes-per-file
class FormBuilderTypeSafe extends forms_1.FormBuilder {
    // override group to be type safe
    group(controlsConfig, extra) {
        /*NOTE the return FormGroupTypeSafe<T> */
        // instantiate group from angular type
        const gr = super.group(controlsConfig, extra);
        if (gr) {
            // implement getSafe method
            gr.getSafe = exports.generateGetSafeFunction(gr);
            // implement setControlSafe
            gr.setControlSafe = exports.generateSetControlSafeFunction(gr);
            // implement more functions as needed
        }
        return gr;
    }
}
exports.FormBuilderTypeSafe = FormBuilderTypeSafe;
